#ifndef _OVDISIS_H_
#define _OVDISIS_H_

#include <linux/types.h>
#include <fb/libfb.h>
#include "../vdidefs.h"

/* Defines for vdipb->contrl[] */

#define ROUTINE 0
#define N_PTSIN 1
#define N_PTSOUT 2
#define N_INTIN 3
#define N_INTOUT 4
#define SUBROUTINE 5
#define VDI_HANDLE 6


extern VDIPB *vdipb;

typedef struct
{
  int font,color;
  int textheight,textwidth,cellheight,cellwidth;
  int effects,h_alignment,v_alignment,rotation;
} TextAttributes;

typedef struct
{
  int color,width,type,ends_beg,ends_end;
  ushort udsty;
} LineAttributes;

typedef struct
{
  int color,height,width,type;
} MarkerAttributes;

typedef struct
{
  int color,interior,style,perimeter,udpat_nbpl;
  ushort udpat[8][16];  /* [bpl][row] */
} FillAttributes;

typedef struct
{
  int x1,y1,x2,y2;
} RECT;

typedef	struct
{
  FB *fb;
  int handle;

  /* v_opnwk & v_opnvwk */
	short	xres, yres;
	short	noscale;
	short	wpixel, hpixel;
	short	cheights;
	short	linetypes, linewidths;
	short	markertypes, markersizes;
	short	faces,	patterns, hatches, colors;
	short	ngdps;
	short	cangdps[10];
	short	gdpattr[10];
	short	cancolor, cantextrot;
	short	canfillarea, cancellarray;
	short	palette;
	short	locators, valuators;
	short	choicedevs, stringdevs;
	short	wstype;
	short	minwchar, minhchar;
	short	maxwchar, maxhchar;
	short	minwline;
	short	zero5;
	short	maxwline;
	short	zero7;
	short	minwmark, minhmark;
	short	maxwmark, maxhmark;

  /* v_extnd */
	short	screentype;
	short	bgcolors, textfx;
	short	canscale;
	short	planes, lut;
	short	rops;
	short	cancontourfill, textrot;
	short	writemodes;
	short	inputmodes;
	short	textalign, inking, rubberbanding;
	short	maxvertices, maxintin;
	short	mousebuttons;
	short	widestyles, widemodes;
	short	reserved[40];

  TextAttributes text_a;
  FillAttributes fill_a;
  LineAttributes line_a;
  MarkerAttributes marker_a;

  int write_mode;
  RECT clip;

} VDI_Workstation;

typedef struct
{
  VDI_Workstation *physical;  /* pointer to physical ws, containing default values */
  VDI_Workstation *vwk;       /* virtual workstation reserved by v_opnvwk */
} VDIWK;

#define MAX_HANDLES 128

/* kind of workstation */
#define WS_NOTOPEN 0
#define WS_PHYSICAL 1
#define WS_VIRTUAL 2

typedef void VdiFunction(VDI_Workstation *);
#define UNUSED (VdiFunction *)NULL


/* debug info defines */
#if DEBUGLEVEL>=1
#define EDEBUG(fmt,args...) fprintf(stderr,fmt,##args)
#if DEBUGLEVEL>=2
#define ADEBUG(fmt,args...) fprintf(stdout,fmt,##args)
#if DEBUGLEVEL>=3
#define IDEBUG(fmt,args...) fprintf(stdout,fmt,##args)
#else  /* 3 */
#define IDEBUG(fmt,args...) 
#endif /* 3 */
#else  /* 2 */
#define ADEBUG(fmt,args...) 
#define IDEBUG(fmt,args...) 
#endif /* 2 */
#else  /* 1 */
#define EDEBUG(fmt,args...) 
#define ADEBUG(fmt,args...) 
#define IDEBUG(fmt,args...) 
#endif /* 1 */

#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))


#endif
