#include <stdio.h>
#include <stdlib.h>

#include "ovdisis.h"
#include "various.h"

#include "defcmap.h"

VDIWK wk[MAX_HANDLES];
int wk_open[MAX_HANDLES];
/* are these zeroed??? */


/* GDOS function */
/* vwk not used by this function */
void vdi_v_opnwk(VDI_Workstation *vwk)
{
  int i,w=0;

  /* find first free handle */
  while((w<MAX_HANDLES) && wk_open[w]) w++;

  if(w==MAX_HANDLES)
    {
      vdipb->contrl[VDI_HANDLE]=0;  /* Could not open workstation */
      EDEBUG("v_opnwk: No handles left to open physical workstation, sorry!\n");
      return;
    }

  if((wk[w].physical=(VDI_Workstation *)malloc((size_t)sizeof(VDI_Workstation)))==NULL)
    {
      vdipb->contrl[VDI_HANDLE]=0;  /* Could not open workstation */
      EDEBUG("v_opnwk: Not enough memory for physical workstation!\n");
      return;
    }
  if((wk[w].physical->fb=FBopen(NULL,FB_OPEN_NEW_VC))==NULL)
    {
      free(wk[w].physical);
      vdipb->contrl[VDI_HANDLE]=0;  /* Could not open workstation */
      EDEBUG("v_opnwk: Error opening FrameBuffer!\n");
      return;
    }

  vdipb->contrl[VDI_HANDLE] = w+1;    /* new vdi handle */
  wk_open[w] = WS_PHYSICAL;
  wk[w].vwk = wk[w].physical; /* Link workstation to physical */

  wk[w].physical->handle = w+1;       /* used for debugging */

  ADEBUG("v_opnwk: Physical workstation, handle %d opened: %lx\n",w+1,(long)wk[w].physical);
  ADEBUG("v_opnwk: FrameBuffer opened: %lx\n",(long)wk[w].physical->fb);

  /* Setting default values */

  /* v_opnvwk */
  vdipb->intout[ 0] = wk[w].physical->xres = wk[w].physical->fb->vinf.xres;
  vdipb->intout[ 1] = wk[w].physical->yres = wk[w].physical->fb->vinf.yres;
  vdipb->intout[ 2] = wk[w].physical->noscale = 0;
  vdipb->intout[ 3] = wk[w].physical->wpixel = (wk[w].physical->fb->vinf.width*1000)/wk[w].physical->xres;
  vdipb->intout[ 4] = wk[w].physical->hpixel = (wk[w].physical->fb->vinf.height*1000)/wk[w].physical->yres;
  vdipb->intout[ 5] = wk[w].physical->cheights = -1;
  vdipb->intout[ 6] = wk[w].physical->linetypes = 7;
  vdipb->intout[ 7] = wk[w].physical->linewidths = 0;
  vdipb->intout[ 8] = wk[w].physical->markertypes = 6;
  vdipb->intout[ 9] = wk[w].physical->markersizes = 0;
  vdipb->intout[10] = wk[w].physical->faces = 1;
  vdipb->intout[11] = wk[w].physical->patterns = 24;
  vdipb->intout[12] = wk[w].physical->hatches = 12;
  /* if truecolor number of virtual pens. In normal VDI 256 virtual pens */
  vdipb->intout[13] = wk[w].physical->colors = 1 << wk[w].physical->fb->vinf.bits_per_pixel;
  vdipb->intout[14] = wk[w].physical->ngdps = 10;
  for(i=0 ; i<10 ; i++)
    vdipb->intout[15+i] = wk[w].physical->cangdps[i] = i+1;
  vdipb->intout[25] = wk[w].physical->gdpattr[0] = 3;
  vdipb->intout[26] = wk[w].physical->gdpattr[1] = 0;
  vdipb->intout[27] = wk[w].physical->gdpattr[2] = 3;
  vdipb->intout[28] = wk[w].physical->gdpattr[3] = 3;
  vdipb->intout[29] = wk[w].physical->gdpattr[4] = 3;
  vdipb->intout[30] = wk[w].physical->gdpattr[5] = 0;
  vdipb->intout[31] = wk[w].physical->gdpattr[6] = 3;
  vdipb->intout[32] = wk[w].physical->gdpattr[7] = 0;
  vdipb->intout[33] = wk[w].physical->gdpattr[8] = 3;
  vdipb->intout[34] = wk[w].physical->gdpattr[9] = 2;
  vdipb->intout[35] = wk[w].physical->cancolor = (wk[w].physical->fb->vinf.bits_per_pixel>1?1:0);
  vdipb->intout[36] = wk[w].physical->cantextrot = 0;
  vdipb->intout[37] = wk[w].physical->cancellarray = 0;
  i = ((1<<wk[w].physical->fb->vinf.red.length) * 
       (1<<wk[w].physical->fb->vinf.green.length) *
       (1<<wk[w].physical->fb->vinf.blue.length));
  vdipb->intout[38] = wk[w].physical->palette = ( i>32767 ? 0 : i);
  vdipb->intout[39] = wk[w].physical->locators = 1;
  vdipb->intout[40] = wk[w].physical->valuators = 1;
  vdipb->intout[41] = wk[w].physical->choicedevs = 1;
  vdipb->intout[42] = wk[w].physical->stringdevs = 1;
  vdipb->intout[43] = wk[w].physical->wstype = 2;

  vdipb->ptsout[ 0] = wk[w].physical->minhchar = -1;
  vdipb->ptsout[ 1] = wk[w].physical->maxwchar = -1;
  vdipb->ptsout[ 2] = wk[w].physical->maxhchar = -1;
  vdipb->ptsout[ 3] = wk[w].physical->minwline = 1;
  vdipb->ptsout[ 4] = wk[w].physical->zero5    = 0;
  vdipb->ptsout[ 5] = wk[w].physical->maxwline = 40;
  vdipb->ptsout[ 6] = wk[w].physical->zero7    = 0;
  vdipb->ptsout[ 7] = wk[w].physical->minwmark = 1;
  vdipb->ptsout[ 8] = wk[w].physical->minhmark = 1;
  vdipb->ptsout[ 9] = wk[w].physical->maxwmark = 1999;
  vdipb->ptsout[10] = wk[w].physical->maxhmark = 1999;

  /* v_extnd */
  wk[w].physical->screentype = 4;
  wk[w].physical->bgcolors = wk[w].physical->palette;
  wk[w].physical->textfx = -1;
  wk[w].physical->canscale = 0;
  wk[w].physical->planes = wk[w].physical->fb->vinf.bits_per_pixel;
  wk[w].physical->lut = 1;
  wk[w].physical->rops = 100;   /* 16x16 pixel raster operations per second! No idea! */
  wk[w].physical->cancontourfill = 0;
  wk[w].physical->textrot = 0;
  wk[w].physical->writemodes = 4;
  wk[w].physical->inputmodes = 2;  /* ? */
  wk[w].physical->textalign = 0;
  wk[w].physical->inking = 0;
  wk[w].physical->rubberbanding = 0;
  wk[w].physical->maxvertices = -1;    /* -1 == infinit */
  wk[w].physical->maxintin = -1;       /* -1 == infinit */
  wk[w].physical->mousebuttons = 2;    /* 3 in X ??? */
  wk[w].physical->widestyles = 0;
  wk[w].physical->widemodes = 0;
  for(i=0 ; i<40 ; i++)
    wk[w].physical->reserved[i] = 0;

  wk[w].physical->write_mode = MD_REPLACE;
  wk[w].physical->clip.x1 = 0;
  wk[w].physical->clip.y1 = 0;
  wk[w].physical->clip.x2 = wk[w].physical->xres;
  wk[w].physical->clip.y2 = wk[w].physical->yres;

  IDEBUG("v_opnwk: Number of bitplanes: %d\n",wk[w].physical->planes);

  /* Set default palette */
  switch(wk[w].physical->planes)
    {
    case 1:
      FBputcmap(wk[w].physical->fb, &default_cmap_1bpl);
      break;
    case 2:
      FBputcmap(wk[w].physical->fb, &default_cmap_2bpl);
      break;
    case 4:
      FBputcmap(wk[w].physical->fb, &default_cmap_4bpl);
      break;
    case 8:
      FBputcmap(wk[w].physical->fb, &default_cmap_8bpl);
      break;
    default:
      FBputcmap(wk[w].physical->fb, &default_cmap_8bpl);
      break;
    }
  ADEBUG("v_opnwk: Default palette set\n");
  
  vdipb->contrl[N_PTSOUT]=6;
  vdipb->contrl[N_INTOUT]=45;
}

/* GDOS function */
/* vwk not used */
void vdi_v_clswk(VDI_Workstation *vwk)
{
  int i,w;

  w=vdipb->contrl[VDI_HANDLE]-1;

  if(wk_open[w]!=WS_PHYSICAL)
    {
      if(wk_open[w])
	EDEBUG("v_clswk: Physical workstation, handle %d not open!",w+1);
      else
	EDEBUG("v_clswk: Handle %d is not a physical workstation!",w+1);
      return;
    }

  FBclose(wk[w].physical->fb);
  ADEBUG("v_clswk: FrameBuffer closed\n");

  /* Free virtual workstations left open */
  /* Will closing a physical workstation
     also close all its virtual ? */
  /* It will here! */
  for(i=0 ; i<MAX_HANDLES ; i++)
    if(wk_open[i] && (wk[i].physical==wk[w].physical))
      {
	free(wk[i].vwk);
	wk_open[i] = WS_NOTOPEN;
	ADEBUG("v_clswk: Freed workstation, handle %d\n",i+1);
      }
  ADEBUG("v_clswk: Freed physical workstation, handle %d\n",w+1);

  /* Above will also free the actual physical ws */

  /* Free physical VDI_Workstation */
  /*
    free(wk[w].physical);
    ADEBUG("v_clswk: Freed physical workstation, handle %d\n",w+1);
    */

  wk_open[w] = WS_NOTOPEN;
}




/* This function does not open a framebuffer,
   but only allocate a new virtual workstation. */
void vdi_v_opnvwk(VDI_Workstation *vwk)
{
  int i,v=0,w;

  w = vdipb->contrl[VDI_HANDLE]-1; /* Physical workstation */

  if(wk_open[w]!=WS_PHYSICAL)
    {
      vdipb->contrl[VDI_HANDLE]=0;  /* Could not open virtual workstation */
      EDEBUG("v_opnvwk: Handle %d is not a physical workstation!\n",w+1);
      return;
    }

  /* find first free handle */
  while( (v<MAX_HANDLES) && wk_open[v] ) v++;

  /* none free found */
  if(v==MAX_HANDLES)
    {
      vdipb->contrl[VDI_HANDLE]=0;  /* Could not open virtual workstation */
      EDEBUG("v_opnvwk: We're all out of handles I'm afraid!\n");
      return;
    }

  /* malloc space for new virtual workstation */
  if((wk[v].vwk=(VDI_Workstation *)malloc((size_t)sizeof(VDI_Workstation)))==NULL)
    {
      vdipb->contrl[VDI_HANDLE]=0;  /* Could not open virtual workstation */
      EDEBUG("v_opnvwk: Not enough memory for new workstation!\n");
      return;
    }

  ADEBUG("v_opnvwk: New virtual workstation, handle %d opened linked to %d\n",v+1,w+1);

  vdipb->contrl[VDI_HANDLE] = v+1;    /* new vdi handle */
  wk_open[v] = WS_VIRTUAL;
  wk[v].physical = wk[w].physical;    /* link virtual to physical, sort of */
  wk[v].vwk->fb = wk[v].physical->fb; /* same FB as physical workstation */

  wk[v].vwk->handle = v+1;            /* used for debugging */

  /* intin[0] - workstation (1-10 == screen) */
  wk[v].vwk->line_a.type     = (int)vdipb->intin[1];
  wk[v].vwk->line_a.color    = (int)vdipb->intin[2];
  wk[v].vwk->marker_a.type   = (int)vdipb->intin[3];
  wk[v].vwk->marker_a.color  = (int)vdipb->intin[4];
  wk[v].vwk->text_a.font     = (int)vdipb->intin[5];
  wk[v].vwk->text_a.color    = (int)vdipb->intin[6];
  wk[v].vwk->fill_a.interior = (int)vdipb->intin[7];
  wk[v].vwk->fill_a.style    = (int)vdipb->intin[8];
  wk[v].vwk->fill_a.color    = (int)vdipb->intin[9];
  /* intin[10] - Coordinate system.  Only used in GDOS */

  /* setup virtual workstation as the physical */
  vdipb->intout[ 0] = (short) wk[v].vwk->xres = wk[v].physical->xres;
  vdipb->intout[ 1] = (short) wk[v].vwk->yres = wk[v].physical->yres;
  vdipb->intout[ 2] = (short) wk[v].vwk->noscale = wk[v].physical->noscale;
  vdipb->intout[ 3] = (short) wk[v].vwk->wpixel = wk[v].physical->wpixel;
  vdipb->intout[ 4] = (short) wk[v].vwk->hpixel = wk[v].physical->hpixel;
  vdipb->intout[ 5] = (short) wk[v].vwk->cheights = wk[v].physical->cheights;
  vdipb->intout[ 6] = (short) wk[v].vwk->linetypes = wk[v].physical->linetypes;
  vdipb->intout[ 7] = (short) wk[v].vwk->linewidths = wk[v].physical->linewidths;
  vdipb->intout[ 8] = (short) wk[v].vwk->markertypes = wk[v].physical->markertypes;
  vdipb->intout[ 9] = (short) wk[v].vwk->markersizes = wk[v].physical->markersizes;
  vdipb->intout[10] = (short) wk[v].vwk->faces = wk[v].physical->faces;
  vdipb->intout[11] = (short) wk[v].vwk->patterns = wk[v].physical->patterns;
  vdipb->intout[12] = (short) wk[v].vwk->hatches = wk[v].physical->hatches;
  vdipb->intout[13] = (short) wk[v].vwk->colors = wk[v].physical->colors;
  vdipb->intout[14] = (short) wk[v].vwk->ngdps = wk[v].physical->ngdps;
  for(i=0 ; i<10 ; i++)
    vdipb->intout[15+i] = (short) wk[v].vwk->cangdps[i] = wk[v].physical->cangdps[i];
  for(i=0 ; i<10 ; i++)
    vdipb->intout[25+i] = (short) wk[v].vwk->gdpattr[i] = wk[v].physical->gdpattr[i];
  vdipb->intout[35] = (short) wk[v].vwk->cancolor = wk[v].physical->cancolor;
  vdipb->intout[36] = (short) wk[v].vwk->cantextrot = wk[v].physical->cantextrot;
  vdipb->intout[37] = (short) wk[v].vwk->canfillarea = wk[v].physical->canfillarea;
  vdipb->intout[38] = (short) wk[v].vwk->cancellarray = wk[v].physical->cancellarray;
  vdipb->intout[39] = (short) wk[v].vwk->palette = wk[v].physical->palette;
  vdipb->intout[40] = (short) wk[v].vwk->locators = wk[v].physical->locators;
  vdipb->intout[41] = (short) wk[v].vwk->valuators = wk[v].physical->valuators;
  vdipb->intout[42] = (short) wk[v].vwk->choicedevs = wk[v].physical->choicedevs;
  vdipb->intout[43] = (short) wk[v].vwk->stringdevs = wk[v].physical->stringdevs;
  vdipb->intout[44] = (short) wk[v].vwk->wstype = wk[v].physical->wstype;

  vdipb->ptsout[ 0] = (short) wk[v].vwk->minwchar = wk[v].physical->minwchar;
  vdipb->ptsout[ 1] = (short) wk[v].vwk->minhchar = wk[v].physical->minhchar;
  vdipb->ptsout[ 2] = (short) wk[v].vwk->maxwchar = wk[v].physical->maxwchar;
  vdipb->ptsout[ 3] = (short) wk[v].vwk->maxhchar = wk[v].physical->maxhchar;
  vdipb->ptsout[ 4] = (short) wk[v].vwk->minwline = wk[v].physical->minwline;
  vdipb->ptsout[ 5] = (short) wk[v].vwk->zero5 = wk[v].physical->zero5;
  vdipb->ptsout[ 6] = (short) wk[v].vwk->maxwline = wk[v].physical->maxwline;
  vdipb->ptsout[ 7] = (short) wk[v].vwk->zero7 = wk[v].physical->zero7;
  vdipb->ptsout[ 8] = (short) wk[v].vwk->minwmark = wk[v].physical->minwmark;
  vdipb->ptsout[ 9] = (short) wk[v].vwk->minhmark = wk[v].physical->minhmark;
  vdipb->ptsout[10] = (short) wk[v].vwk->maxwmark = wk[v].physical->maxwmark;
  vdipb->ptsout[11] = (short) wk[v].vwk->maxhmark = wk[v].physical->maxhmark;

  /* init v_extnd answers too */
  wk[v].vwk->screentype = wk[v].physical->screentype;
  wk[v].vwk->bgcolors = wk[v].physical->bgcolors;
  wk[v].vwk->textfx = wk[v].physical->textfx;
  wk[v].vwk->canscale = wk[v].physical->canscale;
  wk[v].vwk->planes = wk[v].physical->planes;
  wk[v].vwk->lut = wk[v].physical->lut;
  wk[v].vwk->rops = wk[v].physical->rops;
  wk[v].vwk->cancontourfill = wk[v].physical->cancontourfill;
  wk[v].vwk->textrot = wk[v].physical->textrot;
  wk[v].vwk->writemodes = wk[v].physical->writemodes;
  wk[v].vwk->inputmodes = wk[v].physical->inputmodes;
  wk[v].vwk->textalign = wk[v].physical->textalign;
  wk[v].vwk->inking = wk[v].physical->inking;
  wk[v].vwk->rubberbanding = wk[v].physical->rubberbanding;
  wk[v].vwk->maxvertices = wk[v].physical->maxvertices;
  wk[v].vwk->maxintin = wk[v].physical->maxintin;
  wk[v].vwk->mousebuttons = wk[v].physical->mousebuttons;
  wk[v].vwk->widestyles = wk[v].physical->widestyles;
  wk[v].vwk->widemodes = wk[v].physical->widemodes;
  for(i=0 ; i<40 ; i++)
    wk[v].vwk->reserved[i] = wk[v].physical->reserved[i];

  wk[v].vwk->write_mode = wk[v].physical->write_mode;
  wk[v].vwk->clip.x1 = wk[v].physical->clip.x1;
  wk[v].vwk->clip.y1 = wk[v].physical->clip.y1;
  wk[v].vwk->clip.x2 = wk[v].physical->clip.x2;
  wk[v].vwk->clip.y2 = wk[v].physical->clip.y2;

  vdipb->contrl[N_INTOUT]=45;
  vdipb->contrl[N_PTSOUT]=6;
}

void vdi_v_clsvwk(VDI_Workstation *vwk)
{
  int v;

  v = vdipb->contrl[VDI_HANDLE]-1;

  if(wk_open[v]!=WS_VIRTUAL)
    {
      if(wk_open[v])
	EDEBUG("v_clsvwk: Handle %d is not a virtual workstation\n",v+1);
      else
	EDEBUG("v_clsvwk: Handle %d is not open\n",v+1);
      return;
    }

  free(wk[v].vwk);
  wk_open[v] = WS_NOTOPEN;

  ADEBUG("v_clsvwk: Virtual workstation, handle %d freed\n",v+1);
}

void vdi_v_clrwk(VDI_Workstation *vwk)
{
  EDEBUG("v_clrwk: Call not implemented!\n");
}

void vdi_v_updwk(VDI_Workstation *vwk)
{
  EDEBUG("v_updwk: Call not implemented!\n");
}

void vdi_vs_clip(VDI_Workstation *vwk)
{
  if(vdipb->intin[0])
    { /* Clipping on */
      vwk->clip.x1 = vdipb->ptsin[0];
      vwk->clip.y1 = vdipb->ptsin[1];
      vwk->clip.x2 = vdipb->ptsin[2];
      vwk->clip.y2 = vdipb->ptsin[3];
      fix_rect(&vwk->clip);
      vwk->clip.x1 = max(0, vdipb->ptsin[0]);
      vwk->clip.y1 = max(0, vdipb->ptsin[1]);
      vwk->clip.x2 = min(vwk->xres, vdipb->ptsin[2]);
      vwk->clip.y2 = min(vwk->yres, vdipb->ptsin[3]);
    }
  else
    { /* Clipping off */
      vwk->clip.x1 = 0;
      vwk->clip.y1 = 0;
      vwk->clip.x2 = vwk->xres;
      vwk->clip.y2 = vwk->yres;
    }
  ADEBUG("vs_clip: Clipping for handle %d set to: %d, %d, %d, %d.\n",
	 vwk->handle,vwk->clip.x1,vwk->clip.y1,vwk->clip.x2,vwk->clip.y2);
}

void vdi_vswr_mode(VDI_Workstation *vwk)
{
  vwk->write_mode = vdipb->intin[0];
  vdipb->intout[0] = vwk->write_mode;

  vdipb->contrl[N_INTOUT] = 1;
}

void vdi_vq_extnd(VDI_Workstation *vwk)
{
  int i;

  if(vdipb->intin[0])
    {  /* extended answers */
      vdipb->intout[ 0] = (short) vwk->screentype;
      vdipb->intout[ 1] = (short) vwk->bgcolors;
      vdipb->intout[ 2] = (short) vwk->textfx;
      vdipb->intout[ 3] = (short) vwk->canscale;
      vdipb->intout[ 4] = (short) vwk->planes;
      vdipb->intout[ 5] = (short) vwk->lut;
      vdipb->intout[ 6] = (short) vwk->rops;
      vdipb->intout[ 7] = (short) vwk->cancontourfill;
      vdipb->intout[ 8] = (short) vwk->textrot;
      vdipb->intout[ 9] = (short) vwk->writemodes;
      vdipb->intout[10] = (short) vwk->inputmodes;
      vdipb->intout[11] = (short) vwk->textalign;
      vdipb->intout[12] = (short) vwk->inking;
      vdipb->intout[13] = (short) vwk->rubberbanding;
      vdipb->intout[14] = (short) vwk->maxvertices;
      vdipb->intout[15] = (short) vwk->maxintin;
      vdipb->intout[16] = (short) vwk->mousebuttons;
      vdipb->intout[17] = (short) vwk->widestyles;
      vdipb->intout[18] = (short) vwk->widemodes;
      for(i=0 ; i<26 ; i++)
	vdipb->intout[19+i] = (short) vwk->reserved[i];

      for(i=0 ; i<12 ; i++)
	vdipb->ptsout[i] = (short) vwk->reserved[26+i];
    }
  else
    {  /* same answers as from v_opnvwk */
      vdipb->intout[ 0] = (short) vwk->xres;
      vdipb->intout[ 1] = (short) vwk->yres;
      vdipb->intout[ 2] = (short) vwk->noscale;
      vdipb->intout[ 3] = (short) vwk->wpixel;
      vdipb->intout[ 4] = (short) vwk->hpixel;
      vdipb->intout[ 5] = (short) vwk->cheights;
      vdipb->intout[ 6] = (short) vwk->linetypes;
      vdipb->intout[ 7] = (short) vwk->linewidths;
      vdipb->intout[ 8] = (short) vwk->markertypes;
      vdipb->intout[ 9] = (short) vwk->markersizes;
      vdipb->intout[10] = (short) vwk->faces;
      vdipb->intout[11] = (short) vwk->patterns;
      vdipb->intout[12] = (short) vwk->hatches;
      vdipb->intout[13] = (short) vwk->colors;
      vdipb->intout[14] = (short) vwk->ngdps;
      for(i=0 ; i<10 ; i++)
	vdipb->intout[15+i] = (short) vwk->cangdps[i];
      for(i=0 ; i<10 ; i++)
	vdipb->intout[25+i] = (short) vwk->gdpattr[i];
      vdipb->intout[35] = (short) vwk->cancolor;
      vdipb->intout[36] = (short) vwk->cantextrot;
      vdipb->intout[37] = (short) vwk->canfillarea;
      vdipb->intout[38] = (short) vwk->cancellarray;
      vdipb->intout[39] = (short) vwk->palette;
      vdipb->intout[40] = (short) vwk->locators;
      vdipb->intout[41] = (short) vwk->valuators;
      vdipb->intout[42] = (short) vwk->choicedevs;
      vdipb->intout[43] = (short) vwk->stringdevs;
      vdipb->intout[44] = (short) vwk->wstype;

      vdipb->ptsout[ 0] = (short) vwk->minwchar;
      vdipb->ptsout[ 1] = (short) vwk->minhchar;
      vdipb->ptsout[ 2] = (short) vwk->maxwchar;
      vdipb->ptsout[ 3] = (short) vwk->maxhchar;
      vdipb->ptsout[ 4] = (short) vwk->minwline;
      vdipb->ptsout[ 5] = (short) vwk->zero5;
      vdipb->ptsout[ 6] = (short) vwk->maxwline;
      vdipb->ptsout[ 7] = (short) vwk->zero7;
      vdipb->ptsout[ 8] = (short) vwk->minwmark;
      vdipb->ptsout[ 9] = (short) vwk->minhmark;
      vdipb->ptsout[10] = (short) vwk->maxwmark;
      vdipb->ptsout[11] = (short) vwk->maxhmark;
    }

  vdipb->contrl[N_INTOUT]=45;
  vdipb->contrl[N_PTSOUT]=6;
}


