#include <stdio.h>

#include "ovdisis.h"
#include "various.h"

void vdi_vs_color(VDI_Workstation *vwk)
{
  int i;
  unsigned short red,green,blue;
  FBCMAP cmap;

  i = gem2tos_color(vwk->planes, vdipb->intin[0]);
  /* Have to check what should happen if
     color is out of range */
  if(i >= vwk->colors)
    {
      EDEBUG("vs_color: Color index %d out of range!\n",vdipb->intin[0]);
      return;
    }

  red   = (unsigned short)((vdipb->intin[1] * 65535) / 1000);
  green = (unsigned short)((vdipb->intin[2] * 65535) / 1000);
  blue  = (unsigned short)((vdipb->intin[3] * 65535) / 1000);

  cmap.start = cmap.end = i;
  cmap.len   = 1;
  cmap.red   = &red;
  cmap.green = &green;
  cmap.blue  = &blue;
  FBputcmap(vwk->fb, &cmap);

  ADEBUG("vs_color: Vdi color %d is set to: %u, %u, %u\n",
	 vdipb->intin[0],vdipb->intin[1],vdipb->intin[2],vdipb->intin[3]);
  ADEBUG("vs_color: Which means cmap color %d set to: %u, %u, %u\n",
	 i, red, green, blue);
}

void vdi_vq_color(VDI_Workstation *vwk)
{
  int i;
  FBCMAP *cmap;

  cmap = FBgetcmap(vwk->fb);

  if(vdipb->intin[0] > vwk->colors)
    vdipb->intout[0] = -1;    /* Color out of range */
  else
    {
      i = gem2tos_color(vwk->planes, vdipb->intin[0]);
      vdipb->intout[0] = i;

      /*  vdipb->intin[1] is a flag for something!!!!!!! */

      vdipb->intout[1] = (short)((cmap->red[i]   * 1000) / 65535);
      vdipb->intout[2] = (short)((cmap->green[i] * 1000) / 65535);
      vdipb->intout[3] = (short)((cmap->blue[i]  * 1000) / 65535);

      ADEBUG("vq_color: Cmap color %d is %u, %u, %u\n",
	     i, cmap->red[i], cmap->green[i], cmap->blue[i]);
      ADEBUG("vq_color: Which means vdi color %d is %u, %u, %u\n",
	     vdipb->intin[0],vdipb->intout[1],vdipb->intout[2],vdipb->intout[3]);
    }

  FBfreecmap(cmap);

  vdipb->contrl[N_INTOUT] = 4;
}

void vdi_v_get_pixel(VDI_Workstation *vwk)
{
  int ti;

  if((ti = FBgetpixel(vwk->fb, vdipb->ptsin[0], vdipb->ptsin[1])) != 0)
    vdipb->intout[0] = 1;
  else
    vdipb->intout[0] = 0;

  vdipb->intout[1] = tos2gem_color(vwk->planes, ti);

  vdipb->contrl[N_INTOUT] = 2;
}

void vdi_vex_timv(VDI_Workstation *vwk)
{
  EDEBUG("vex_timv: Call not implemented!\n");
}

void vdi_vq_key_s(VDI_Workstation *vwk)
{
  EDEBUG("vq_key_s: Call not implemented!\n");
}

void vdi_vqin_mode(VDI_Workstation *vwk)
{
  EDEBUG("vqin_mode: Call not implemented!\n");
}


